# REST Resource: projects.scanConfigs.scanRuns.findings

- [Resource: Finding](https://docs.cloud.google.com/security-command-center/docs/reference/web-security-scanner/rest/v1beta/projects.scanConfigs.scanRuns.findings#Finding)
  - [JSON representation](https://docs.cloud.google.com/security-command-center/docs/reference/web-security-scanner/rest/v1beta/projects.scanConfigs.scanRuns.findings#Finding.SCHEMA_REPRESENTATION)
- [Severity](https://docs.cloud.google.com/security-command-center/docs/reference/web-security-scanner/rest/v1beta/projects.scanConfigs.scanRuns.findings#Severity)
- [Form](https://docs.cloud.google.com/security-command-center/docs/reference/web-security-scanner/rest/v1beta/projects.scanConfigs.scanRuns.findings#Form)
  - [JSON representation](https://docs.cloud.google.com/security-command-center/docs/reference/web-security-scanner/rest/v1beta/projects.scanConfigs.scanRuns.findings#Form.SCHEMA_REPRESENTATION)
- [OutdatedLibrary](https://docs.cloud.google.com/security-command-center/docs/reference/web-security-scanner/rest/v1beta/projects.scanConfigs.scanRuns.findings#OutdatedLibrary)
  - [JSON representation](https://docs.cloud.google.com/security-command-center/docs/reference/web-security-scanner/rest/v1beta/projects.scanConfigs.scanRuns.findings#OutdatedLibrary.SCHEMA_REPRESENTATION)
- [ViolatingResource](https://docs.cloud.google.com/security-command-center/docs/reference/web-security-scanner/rest/v1beta/projects.scanConfigs.scanRuns.findings#ViolatingResource)
  - [JSON representation](https://docs.cloud.google.com/security-command-center/docs/reference/web-security-scanner/rest/v1beta/projects.scanConfigs.scanRuns.findings#ViolatingResource.SCHEMA_REPRESENTATION)
- [VulnerableHeaders](https://docs.cloud.google.com/security-command-center/docs/reference/web-security-scanner/rest/v1beta/projects.scanConfigs.scanRuns.findings#VulnerableHeaders)
  - [JSON representation](https://docs.cloud.google.com/security-command-center/docs/reference/web-security-scanner/rest/v1beta/projects.scanConfigs.scanRuns.findings#VulnerableHeaders.SCHEMA_REPRESENTATION)
- [Header](https://docs.cloud.google.com/security-command-center/docs/reference/web-security-scanner/rest/v1beta/projects.scanConfigs.scanRuns.findings#Header)
  - [JSON representation](https://docs.cloud.google.com/security-command-center/docs/reference/web-security-scanner/rest/v1beta/projects.scanConfigs.scanRuns.findings#Header.SCHEMA_REPRESENTATION)
- [VulnerableParameters](https://docs.cloud.google.com/security-command-center/docs/reference/web-security-scanner/rest/v1beta/projects.scanConfigs.scanRuns.findings#VulnerableParameters)
  - [JSON representation](https://docs.cloud.google.com/security-command-center/docs/reference/web-security-scanner/rest/v1beta/projects.scanConfigs.scanRuns.findings#VulnerableParameters.SCHEMA_REPRESENTATION)
- [Xss](https://docs.cloud.google.com/security-command-center/docs/reference/web-security-scanner/rest/v1beta/projects.scanConfigs.scanRuns.findings#Xss)
  - [JSON representation](https://docs.cloud.google.com/security-command-center/docs/reference/web-security-scanner/rest/v1beta/projects.scanConfigs.scanRuns.findings#Xss.SCHEMA_REPRESENTATION)
- [Xxe](https://docs.cloud.google.com/security-command-center/docs/reference/web-security-scanner/rest/v1beta/projects.scanConfigs.scanRuns.findings#Xxe)
  - [JSON representation](https://docs.cloud.google.com/security-command-center/docs/reference/web-security-scanner/rest/v1beta/projects.scanConfigs.scanRuns.findings#Xxe.SCHEMA_REPRESENTATION)
- [Location](https://docs.cloud.google.com/security-command-center/docs/reference/web-security-scanner/rest/v1beta/projects.scanConfigs.scanRuns.findings#Location)
- [Methods](https://docs.cloud.google.com/security-command-center/docs/reference/web-security-scanner/rest/v1beta/projects.scanConfigs.scanRuns.findings#METHODS_SUMMARY)

## Resource: Finding

A Finding resource represents a vulnerability instance identified during a ScanRun.

| JSON representation |
|---|
| ``` { "name": string, "findingType": string, "severity": enum (`https://docs.cloud.google.com/security-command-center/docs/reference/web-security-scanner/rest/v1beta/projects.scanConfigs.scanRuns.findings#Severity`), "httpMethod": string, "fuzzedUrl": string, "body": string, "description": string, "reproductionUrl": string, "frameUrl": string, "finalUrl": string, "trackingId": string, "form": { object (`https://docs.cloud.google.com/security-command-center/docs/reference/web-security-scanner/rest/v1beta/projects.scanConfigs.scanRuns.findings#Form`) }, "outdatedLibrary": { object (`https://docs.cloud.google.com/security-command-center/docs/reference/web-security-scanner/rest/v1beta/projects.scanConfigs.scanRuns.findings#OutdatedLibrary`) }, "violatingResource": { object (`https://docs.cloud.google.com/security-command-center/docs/reference/web-security-scanner/rest/v1beta/projects.scanConfigs.scanRuns.findings#ViolatingResource`) }, "vulnerableHeaders": { object (`https://docs.cloud.google.com/security-command-center/docs/reference/web-security-scanner/rest/v1beta/projects.scanConfigs.scanRuns.findings#VulnerableHeaders`) }, "vulnerableParameters": { object (`https://docs.cloud.google.com/security-command-center/docs/reference/web-security-scanner/rest/v1beta/projects.scanConfigs.scanRuns.findings#VulnerableParameters`) }, "xss": { object (`https://docs.cloud.google.com/security-command-center/docs/reference/web-security-scanner/rest/v1beta/projects.scanConfigs.scanRuns.findings#Xss`) }, "xxe": { object (`https://docs.cloud.google.com/security-command-center/docs/reference/web-security-scanner/rest/v1beta/projects.scanConfigs.scanRuns.findings#Xxe`) } } ``` |

| Fields ||
|---|---|
| `name` | `string` The resource name of the Finding. The name follows the format of 'projects/{projectId}/scanConfigs/{scanConfigId}/scanruns/{scanRunId}/findings/{findingId}'. The finding IDs are generated by the system. |
| `findingType` | `string` The type of the Finding. Detailed and up-to-date information on findings can be found here: <https://cloud.google.com/security-command-center/docs/how-to-remediate-web-security-scanner> |
| `severity` | ``enum (`https://docs.cloud.google.com/security-command-center/docs/reference/web-security-scanner/rest/v1beta/projects.scanConfigs.scanRuns.findings#Severity`)`` The severity level of the reported vulnerability. |
| `httpMethod` | `string` The http method of the request that triggered the vulnerability, in uppercase. |
| `fuzzedUrl` | `string` The URL produced by the server-side fuzzer and used in the request that triggered the vulnerability. |
| `body` | `string` The body of the request that triggered the vulnerability. |
| `description` | `string` The description of the vulnerability. |
| `reproductionUrl` | `string` The URL containing human-readable payload that user can leverage to reproduce the vulnerability. |
| `frameUrl` | `string` If the vulnerability was originated from nested IFrame, the immediate parent IFrame is reported. |
| `finalUrl` | `string` The URL where the browser lands when the vulnerability is detected. |
| `trackingId` | `string` The tracking ID uniquely identifies a vulnerability instance across multiple ScanRuns. |
| `form` | ``object (`https://docs.cloud.google.com/security-command-center/docs/reference/web-security-scanner/rest/v1beta/projects.scanConfigs.scanRuns.findings#Form`)`` An addon containing information reported for a vulnerability with an HTML form, if any. |
| `outdatedLibrary` | ``object (`https://docs.cloud.google.com/security-command-center/docs/reference/web-security-scanner/rest/v1beta/projects.scanConfigs.scanRuns.findings#OutdatedLibrary`)`` An addon containing information about outdated libraries. |
| `violatingResource` | ``object (`https://docs.cloud.google.com/security-command-center/docs/reference/web-security-scanner/rest/v1beta/projects.scanConfigs.scanRuns.findings#ViolatingResource`)`` An addon containing detailed information regarding any resource causing the vulnerability such as JavaScript sources, image, audio files, etc. |
| `vulnerableHeaders` | ``object (`https://docs.cloud.google.com/security-command-center/docs/reference/web-security-scanner/rest/v1beta/projects.scanConfigs.scanRuns.findings#VulnerableHeaders`)`` An addon containing information about vulnerable or missing HTTP headers. |
| `vulnerableParameters` | ``object (`https://docs.cloud.google.com/security-command-center/docs/reference/web-security-scanner/rest/v1beta/projects.scanConfigs.scanRuns.findings#VulnerableParameters`)`` An addon containing information about request parameters which were found to be vulnerable. |
| `xss` | ``object (`https://docs.cloud.google.com/security-command-center/docs/reference/web-security-scanner/rest/v1beta/projects.scanConfigs.scanRuns.findings#Xss`)`` An addon containing information reported for an XSS, if any. |
| `xxe` | ``object (`https://docs.cloud.google.com/security-command-center/docs/reference/web-security-scanner/rest/v1beta/projects.scanConfigs.scanRuns.findings#Xxe`)`` An addon containing information reported for an XXE, if any. |

## Severity

The severity level of a vulnerability.

| Enums ||
|---|---|
| `SEVERITY_UNSPECIFIED` | No severity specified. The default value. |
| `CRITICAL` | Critical severity. |
| `HIGH` | High severity. |
| `MEDIUM` | Medium severity. |
| `LOW` | Low severity. |

## Form

! Information about a vulnerability with an HTML.

| JSON representation |
|---|
| ``` { "actionUri": string, "fields": [ string ] } ``` |

| Fields ||
|---|---|
| `actionUri` | `string` ! The URI where to send the form when it's submitted. |
| `fields[]` | `string` ! The names of form fields related to the vulnerability. |

## OutdatedLibrary

Information reported for an outdated library.

| JSON representation |
|---|
| ``` { "libraryName": string, "version": string, "learnMoreUrls": [ string ] } ``` |

| Fields ||
|---|---|
| `libraryName` | `string` The name of the outdated library. |
| `version` | `string` The version number. |
| `learnMoreUrls[]` | `string` URLs to learn more information about the vulnerabilities in the library. |

## ViolatingResource

Information regarding any resource causing the vulnerability such as JavaScript sources, image, audio files, etc.

| JSON representation |
|---|
| ``` { "contentType": string, "resourceUrl": string } ``` |

| Fields ||
|---|---|
| `contentType` | `string` The MIME type of this resource. |
| `resourceUrl` | `string` URL of this violating resource. |

## VulnerableHeaders

Information about vulnerable or missing HTTP Headers.

| JSON representation |
|---|
| ``` { "headers": [ { object (`https://docs.cloud.google.com/security-command-center/docs/reference/web-security-scanner/rest/v1beta/projects.scanConfigs.scanRuns.findings#Header`) } ], "missingHeaders": [ { object (`https://docs.cloud.google.com/security-command-center/docs/reference/web-security-scanner/rest/v1beta/projects.scanConfigs.scanRuns.findings#Header`) } ] } ``` |

| Fields ||
|---|---|
| `headers[]` | ``object (`https://docs.cloud.google.com/security-command-center/docs/reference/web-security-scanner/rest/v1beta/projects.scanConfigs.scanRuns.findings#Header`)`` List of vulnerable headers. |
| `missingHeaders[]` | ``object (`https://docs.cloud.google.com/security-command-center/docs/reference/web-security-scanner/rest/v1beta/projects.scanConfigs.scanRuns.findings#Header`)`` List of missing headers. |

## Header

Describes a HTTP Header.

| JSON representation |
|---|
| ``` { "name": string, "value": string } ``` |

| Fields ||
|---|---|
| `name` | `string` Header name. |
| `value` | `string` Header value. |

## VulnerableParameters

Information about vulnerable request parameters.

| JSON representation |
|---|
| ``` { "parameterNames": [ string ] } ``` |

| Fields ||
|---|---|
| `parameterNames[]` | `string` The vulnerable parameter names. |

## Xss

Information reported for an XSS.

| JSON representation |
|---|
| ``` { "stackTraces": [ string ], "errorMessage": string } ``` |

| Fields ||
|---|---|
| `stackTraces[]` | `string` Stack traces leading to the point where the XSS occurred. |
| `errorMessage` | `string` An error message generated by a javascript breakage. |

## Xxe

Information reported for an XXE.

| JSON representation |
|---|
| ``` { "payloadValue": string, "payloadLocation": enum (`https://docs.cloud.google.com/security-command-center/docs/reference/web-security-scanner/rest/v1beta/projects.scanConfigs.scanRuns.findings#Location`) } ``` |

| Fields ||
|---|---|
| `payloadValue` | `string` The XML string that triggered the XXE vulnerability. Non-payload values might be redacted. |
| `payloadLocation` | ``enum (`https://docs.cloud.google.com/security-command-center/docs/reference/web-security-scanner/rest/v1beta/projects.scanConfigs.scanRuns.findings#Location`)`` Location within the request where the payload was placed. |

## Location

Locations within a request where XML was substituted.

| Enums ||
|---|---|
| `LOCATION_UNSPECIFIED` | Unknown Location. |
| `COMPLETE_REQUEST_BODY` | The XML payload replaced the complete request body. |

| ## Methods ||
|---|---|
| ### `https://docs.cloud.google.com/security-command-center/docs/reference/web-security-scanner/rest/v1beta/projects.scanConfigs.scanRuns.findings/get` | Gets a Finding. |
| ### `https://docs.cloud.google.com/security-command-center/docs/reference/web-security-scanner/rest/v1beta/projects.scanConfigs.scanRuns.findings/list` | List Findings under a given ScanRun. |